dect
/
asterisk
Archived
13
0
Fork 0
This repository has been archived on 2022-02-17. You can view files and clone it, but cannot push or open issues or pull requests.
asterisk/safe_asterisk

78 lines
1.7 KiB
Bash
Executable File

#!/bin/sh
TTY=9 # TTY (if you want one) for Asterisk to run on
CONSOLE=yes # Whether or not you want a console
#NOTIFY=ben@alkaloid.net # Who to notify about crashes
DUMPDROP=/tmp
#
# Don't fork when running "safely"
#
ASTARGS=""
if [ "$TTY" != "" ]; then
if [ -c /dev/tty${TTY} ]; then
TTY=tty${TTY}
elif [ -c /dev/vc/${TTY} ]; then
TTY=vc/${TTY}
else
echo "Cannot find your TTY (${TTY})" >&2
exit 1
fi
ASTARGS="${ASTARGS} -vvvg"
if [ "$CONSOLE" != "no" ]; then
ASTARGS="${ASTARGS} -c"
fi
fi
if [ ! -w ${DUMPDROP} ]; then
echo "Cannot write to ${DUMPDROP}" >&2
exit 1
fi
#
# Let Asterisk dump core
#
ulimit -c unlimited
#launch_asterisk()
#{
#}
run_asterisk()
{
while :; do
if [ "$TTY" != "" ]; then
cd /tmp
stty sane < /dev/${TTY}
asterisk ${ASTARGS} >& /dev/${TTY} < /dev/${TTY}
else
cd /tmp
asterisk ${ASTARGS}
fi
EXITSTATUS=$?
echo "Asterisk ended with exit status $EXITSTATUS"
if [ "$EXITSTATUS" = "0" ]; then
# Properly shutdown....
echo "Asterisk shutdown normally."
exit 0
elif [ $EXITSTATUS -gt 128 ]; then
let EXITSIGNAL=EXITSTATUS-128
echo "Asterisk exited on signal $EXITSIGNAL."
if [ "$NOTIFY" != "" ]; then
echo "Asterisk exited on signal $EXITSIGNAL. Might want to take a peek." | \
mail -s "Asterisk Died" $NOTIFY
fi
if [ -f /tmp/core ]; then
mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` &
fi
else
echo "Asterisk died with code $EXITSTATUS. Aborting."
if [ -f /tmp/core ]; then
mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` &
fi
exit 0
fi
echo "Automatically restarting Asterisk."
done
}
run_asterisk &